#include "install.h"
#include <stdio.h>
#include <string.h>
#include <String.h>

int main(int argc, const char **argv) {
	BVolume volume;
	BNode node(argv[1]);
	
	node.GetVolume(&volume);
	if (node.InitCheck() == B_OK)
		install_init(&volume);
	else
		install_init();
	
	if (argc < 3) {
		printf("Package Marker 1.0\n"
			   "Placed in the public domain Semptember 23, 2000\n\n"
			   "\tpkgmark 'filename' 'package name'\n"
			   "\tpkgmark -sv 'software valet install log' ['package name']\n\n"
			   "\te.g. pkgmark /boot/home/great_software \"Great Software\"\n"
			   "\t     pkgmark -sv \"/boot/home/Install Log\"\n"
			   );
		return 0;
	}
	if (strcmp(argv[1],"-sv") == 0) {
		BFile log(argv[2],B_READ_ONLY);
		char package_name[255];
		char file_name[B_PATH_NAME_LENGTH];
		
		if (log.InitCheck() != B_OK) {
			printf("%s does not exist.\n",argv[2]);
			return -1;
		}
		log.Seek(0,SEEK_END);
		size_t size = log.Position();
		char *buffer = new char[size+1];
		log.Seek(0,SEEK_SET);
		log.Read(buffer,size);
		buffer[size] = 0;
		BString work(buffer);
		delete buffer;
		
		int32 position, end;
		position = work.FindFirst("Installation: ") + 14;
		end = work.FindFirst('\n',position);
		strncpy(package_name,(char *)((int32)work.String() + position),end - position);
		package_name[end-position] = 0;
		if (argc > 3)
			strcpy(package_name,argv[3]);
#ifdef DEBUG_ON
	printf("package_name: %s\n\n",package_name);
#endif
		for (position = work.FindFirst("\n\n\n",position) + 2;(position = work.FindFirst("\n/",position)) != -1;) {
			position ++;
			end = work.FindFirst('\n',position);
			strncpy(file_name,(char *)((int32)work.String() + position),end - position);
			file_name[end-position] = '\0';
			node.SetTo(file_name);
			mark_file(&node,package_name);
#ifdef DEBUG_ON
	printf("\t%s\n",file_name);
#endif
		}	
		
	} else {
		if (node.IsDirectory()) {
			BDirectory dir(argv[1]);
			mark_dir(&dir,argv[2]);
		} else
			mark_file(&node,argv[2]);
	}
}